// b32tedlg.cpp : implementation file
//

#include "stdafx.h"
#include "b32test.h"
#include "b32tedlg.h"
#include "..\btriev32.h"
#include "..\btrthk.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

// Here is the data record
// pack it on 1 byte to make life a little easier...
#pragma pack (1)
struct 
{
	char szName [10];
	short sAmount;
} stBilling;
#pragma pack ()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA


// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg message handlers

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CenterWindow();
	
	// TODO: Add extra about dlg initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

/////////////////////////////////////////////////////////////////////////////
// CB32testDlg dialog

CB32testDlg::CB32testDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CB32testDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CB32testDlg)
	m_cszName = _T("");
	m_iAmount = 0;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// Initialize private members
	iKey = 0;
	memset (posBlk, 0, sizeof (posBlk));
	memset (szKey, 0, sizeof (szKey));
	nLen = 0;

}

void CB32testDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CB32testDlg)
	DDX_Text(pDX, IDC_NAME, m_cszName);
	DDV_MaxChars(pDX, m_cszName, 9);
	DDX_Text(pDX, IDC_AMOUNT, m_iAmount);
	DDV_MinMaxInt(pDX, m_iAmount, -32000, 32000);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CB32testDlg, CDialog)
	//{{AFX_MSG_MAP(CB32testDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_CHANGEKEY, OnChangekey)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(ID_GETFIRST, OnGetfirst)
	ON_BN_CLICKED(ID_GETNEXT, OnGetnext)
	ON_BN_CLICKED(ID_GETNAME, OnGetname)
	ON_BN_CLICKED(ID_GETAMOUNT, OnGetamount)
	ON_BN_CLICKED(ID_GETLAST, OnGetlast)
	ON_BN_CLICKED(ID_GETPREV, OnGetprev)
	ON_BN_CLICKED(ID_UPDATE, OnUpdate)
	ON_BN_CLICKED(ID_INSERT, OnInsert)
	ON_BN_CLICKED(ID_DELETE, OnDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CB32testDlg message handlers

BOOL CB32testDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CenterWindow();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}
	
	// Initialize Btrieve
	OFWBTRVINIT32("/M:48/P:2048/F:30");

	
	// Open or create the datafile
	CString csz = "Datafile \"DATA.DAT\" opened";
	struct FIL_SPEC fileSpecBuff;

	memset(&fileSpecBuff,'\0',sizeof(fileSpecBuff));
	fileSpecBuff.REC_LEN = sizeof(stBilling);
	fileSpecBuff.PAGE_SIZ = 2048;
	fileSpecBuff.FILE_FLAG = 0;
	fileSpecBuff.NDX_CNT = 2;

	fileSpecBuff.KEY_BUF[0].KEY_POS = 1;
	fileSpecBuff.KEY_BUF[0].KEY_LEN = 10;
	fileSpecBuff.KEY_BUF[0].KEY_FLAG = EXT_TYPE|MOD;
	fileSpecBuff.KEY_BUF[0].KEY_TYPE = B_ZSTR_TYPE;
									   
	fileSpecBuff.KEY_BUF[1].KEY_POS = 11;
	fileSpecBuff.KEY_BUF[1].KEY_LEN = 2;
	fileSpecBuff.KEY_BUF[1].KEY_FLAG = EXT_TYPE|MOD|DUP;
	fileSpecBuff.KEY_BUF[1].KEY_TYPE = B_INT_TYPE;

	nLen = sizeof(fileSpecBuff);
	BOOL fOverwrite = FALSE; // Don't overwrite if the file exists
	int nStat = OFBTRCALL32(B_CREATE,posBlk,(char *)&fileSpecBuff,&nLen,"DATA.DAT",(fOverwrite == TRUE ? 0 : -1),-1);

	BOOL fNewFile = (BERR_NONE == nStat);

	nLen = 0;
	nStat = OFBTRCALL32(B_OPEN,posBlk,(char *)"",&nLen,"DATA.DAT", 0, 0);

	if (fNewFile)
	{
		nLen = sizeof (stBilling);
		// Insert 5 random records
		memset (&stBilling, 0, sizeof (stBilling));
		strcpy (stBilling.szName, "Basinger");
		stBilling.sAmount = 200;
		nStat = OFBTRCALL32(B_INSERT,posBlk,(char *)&stBilling,&nLen,szKey,10,0);

		memset (&stBilling, 0, sizeof (stBilling));
		strcpy (stBilling.szName, "Pfeiffer");
		stBilling.sAmount = 100;
		nStat = OFBTRCALL32(B_INSERT,posBlk,(char *)&stBilling,&nLen,szKey,10,0);

		memset (&stBilling, 0, sizeof (stBilling));
		strcpy (stBilling.szName, "Kidman");
		stBilling.sAmount = 700;
		nStat = OFBTRCALL32(B_INSERT,posBlk,(char *)&stBilling,&nLen,szKey,10,0);

		memset (&stBilling, 0, sizeof (stBilling));
		strcpy (stBilling.szName, "Madonna");
		stBilling.sAmount = 900;
		nStat = OFBTRCALL32(B_INSERT,posBlk,(char *)&stBilling,&nLen,szKey,10,0);

		memset (&stBilling, 0, sizeof (stBilling));
		strcpy (stBilling.szName, "Bullock");
		stBilling.sAmount = 500;
		nStat = OFBTRCALL32(B_INSERT,posBlk,(char *)&stBilling,&nLen,szKey,10,0);

		csz = "Datafile \"DATA.DAT\" created and 5 records inserted";
	}

	Info (csz);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CB32testDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CB32testDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CB32testDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CB32testDlg::OnChangekey() 
{
	iKey = (iKey==0 ? 1 : 0);
	// get current pos

	int nLen = 4;
	int nStat = OFBTRCALL32(B_GET_POS,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);
	nLen = sizeof (stBilling);
	nStat = OFBTRCALL32(B_GET_DIRECT,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);

	CString csz;
	wsprintf (csz.GetBuffer(100), "Key changed, now %d", iKey);
	csz.ReleaseBuffer();
	Info (csz);
}

void CB32testDlg::Info (CString &csz)
{
	CStatic *pStatic = (CStatic *) GetDlgItem (IDC_INFOTEXT);
	pStatic->SetWindowText (csz);
}

void CB32testDlg::OnClose() 
{
	
	CDialog::OnClose();
	
}

void CB32testDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// Close down btrieve
	OFWBTRVSTOP32 ();

}

void CB32testDlg::OnGetfirst() 
{
	int nLen = sizeof (stBilling);
	int nStat = OFBTRCALL32(B_GET_LO,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);
	
	if (BERR_NONE == nStat)
	{
		m_cszName = stBilling.szName;
		m_iAmount = stBilling.sAmount;
		UpdateData (FALSE);
	}

	CString csz;
	wsprintf (csz.GetBuffer(100), "GetFirst, status %d", nStat);
	csz.ReleaseBuffer();
	Info (csz);
}

void CB32testDlg::OnGetnext() 
{
	int nLen = sizeof (stBilling);
	int nStat = OFBTRCALL32(B_GET_NEXT,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);
	
	if (BERR_NONE == nStat)
	{
		m_cszName = stBilling.szName;
		m_iAmount = stBilling.sAmount;
		UpdateData (FALSE);
	}

	CString csz;
	wsprintf (csz.GetBuffer(100), "GetNext, status %d", nStat);
	csz.ReleaseBuffer();
	Info (csz);
		
}

void CB32testDlg::OnGetname() 
{
	int nLen = sizeof (stBilling);
	strcpy (szKey, "Kidman");

	int nStat = OFBTRCALL32(B_GET_EQ,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), 0);

	OFBTRCALL32(B_GET_POS,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);
	nLen = sizeof (stBilling);
	OFBTRCALL32(B_GET_DIRECT,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);


	
	if (BERR_NONE == nStat)
	{
		m_cszName = stBilling.szName;
		m_iAmount = stBilling.sAmount;
		UpdateData (FALSE);
	}

	CString csz;
	wsprintf (csz.GetBuffer(100), "Get Equal, status %d", nStat);
	csz.ReleaseBuffer();
	Info (csz);
		
}

void CB32testDlg::OnGetamount() 
{
	int nLen = sizeof (stBilling);
	short sSearchKey = 500;

	int nStat = OFBTRCALL32(B_GET_GTE,posBlk,(char *)&stBilling,&nLen,(char *) &sSearchKey, sizeof (sSearchKey), 1);

	OFBTRCALL32(B_GET_POS,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);
	nLen = sizeof (stBilling);
	OFBTRCALL32(B_GET_DIRECT,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);

	
	if (BERR_NONE == nStat)
	{
		m_cszName = stBilling.szName;
		m_iAmount = stBilling.sAmount;
		UpdateData (FALSE);
	}

	CString csz;
	wsprintf (csz.GetBuffer(100), "Get Greater or Equal, status %d", nStat);
	csz.ReleaseBuffer();
	Info (csz);
	
}

void CB32testDlg::OnGetlast() 
{
	int nLen = sizeof (stBilling);
	int nStat = OFBTRCALL32(B_GET_HI,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);
	
	if (BERR_NONE == nStat)
	{
		m_cszName = stBilling.szName;
		m_iAmount = stBilling.sAmount;
		UpdateData (FALSE);
	}

	CString csz;
	wsprintf (csz.GetBuffer(100), "GetLast, status %d", nStat);
	csz.ReleaseBuffer();
	Info (csz);
		
}

void CB32testDlg::OnGetprev() 
{
	int nLen = sizeof (stBilling);
	int nStat = OFBTRCALL32(B_GET_PREV,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);
	
	if (BERR_NONE == nStat)
	{
		m_cszName = stBilling.szName;
		m_iAmount = stBilling.sAmount;
		UpdateData (FALSE);
	}

	CString csz;
	wsprintf (csz.GetBuffer(100), "GetPrev, status %d", nStat);
	csz.ReleaseBuffer();
	Info (csz);
}

void CB32testDlg::OnUpdate() 
{
	if (UpdateData ())
	{
		memset (&stBilling, 0, sizeof (stBilling));
		strcpy (stBilling.szName, m_cszName);
		stBilling.sAmount = (short) m_iAmount;
	
		int nLen = sizeof (stBilling);
		int nStat = OFBTRCALL32(B_UPDATE,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);
	

		CString csz;
		wsprintf (csz.GetBuffer(100), "Update, status %d", nStat);
		csz.ReleaseBuffer();
		Info (csz);
	}	
}

void CB32testDlg::OnInsert() 
{
	if (UpdateData ())
	{
		memset (&stBilling, 0, sizeof (stBilling));
		strcpy (stBilling.szName, m_cszName);
		stBilling.sAmount = (short) m_iAmount;
	
		int nLen = sizeof (stBilling);
		int nStat = OFBTRCALL32(B_INSERT,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);
	

		CString csz;
		wsprintf (csz.GetBuffer(100), "Insert, status %d", nStat);
		csz.ReleaseBuffer();
		Info (csz);
	}	
}

void CB32testDlg::OnDelete() 
{
	int nStat = OFBTRCALL32(B_DELETE,posBlk,(char *)&stBilling,&nLen,szKey, sizeof (szKey), iKey);
	if (BERR_NONE == nStat)
	{
		m_cszName = "";
		m_iAmount = 0;
		UpdateData(FALSE);
	}

	CString csz;
	wsprintf (csz.GetBuffer(100), "Delete, status %d", nStat);
	csz.ReleaseBuffer();
	Info (csz);
}
